#include "bits/stdc++.h"
using namespace std;
#define int long long

using ld = long double;

const int N = 101, K = 31;
int dp[K][N][N];
int bits[K][N];
int one_pref[K][N];

inline int ones(int k, int l, int r) {
	return one_pref[k][r] - one_pref[k][l] + bits[k][l];
}

signed main() {
	int t;
	cin >> t;
	for (; t; t--) {
		int n, k;
		cin >> n >> k;

		for (int i = 0; i < n; ++i) {
			string s;
			cin >> s;
			for (int j = 0; j < k; ++j) {
				bits[j][i] = s[j] == '1';
			}
		}

		for (int i = 0; i < k; ++i) {
			for (int j = 0; j < n; ++j) {
				one_pref[i][j] = (j ? one_pref[i][j - 1] : 0) + bits[i][j];
			}
		}
		memset(dp, 0, sizeof dp);

		for (int i = k - 1; i >= 0; --i) {
			for (int l = 0; l < n; ++l) {
				for (int r = l; r < n; ++r) {
					dp[i][l][r] = (r - l + 1) - ones(i, l, r) + ((i != k - 1) ? dp[i + 1][l][r] : 0);
					for (int zero_end = l; zero_end <= r; ++zero_end) {
						int cost_left = ones(i, l, zero_end);
						int cost_right = (r - zero_end) - (one_pref[i][r] - one_pref[i][zero_end]);
						int cost = cost_left + cost_right;
						if (i != k - 1)
							cost += dp[i + 1][l][zero_end];
						if (zero_end < r && i != k - 1) cost += dp[i + 1][zero_end + 1][r];
						dp[i][l][r] = min(dp[i][l][r], cost);
					}
				}
			}
		}

		cout << dp[0][0][n - 1] << endl;
	}
}
